import java.util.*;
import java.text.*;

public class Empregado 
{		public Empregado (String nome, double salario, String dataAdmissao)
		{		this.nome = nome;
				this.salario = salario;

				int dia = Integer.parseInt(dataAdmissao.substring(0,2));
				int mes = Integer.parseInt(dataAdmissao.substring(3,5));
				int ano = Integer.parseInt(dataAdmissao.substring(6,10));

				this.dataAdmissao = new GregorianCalendar(ano, mes - 1, dia);

				/* 	O mtodo parseInt() gera a exceo NumberFormatException
						e o mtodo substring() gera a exceo 
						ArrayIndexOutOfBoundsException. Estas excees so do tipo 
						unchecked, logo o compilador no obriga o programador a 
        		declarar que este  mtodo gera estas excees. 

						(throws NumberFormatException, ArrayIndexOutOfBoundsException) 

				  	Toda exceo que deriva das  classes Error e  Runtime so
				   	consideradas  unchecked exceptions. O programador deve se
				   	preocupar com as excees do tipo checked, manipulando-as
				   	ou anunciando que elas podem ser propagadas.
				
				   	Excees do tipo unchecked so:
				   	- Um acesso fora dos limites de um array
				   	- Um acesso a um ponteiro null, etc.
				
				   	Hierarquia das classes que representam excees:
				
				      Throwable
					       Error                 -  unchecked exceptions
					       Exception
					          IOException        -  checked exceptions
					          RuntimeException   -  unchecked exceptions
				*/

				numero = ++contador;	// Caso a data de admisso seja 
															// invlida o contador no ser
															// incrementado.
		}

		public void imprime()
		{		System.out.println ("Nmero = " + numero + 
														"  Nome = " + nome + 
														"  Salrio = " + getSalario() +
														"  Data de Admisso = " + getDataAdmissao());
		}

		public int getNumero()
		{		return numero;
		}

		public String getNome()
		{		return nome;
		}
		
		public String getSalario()
		{		return nf2.format(salario);
		}
		
		public String getDataAdmissao()
		{		return nf1.format(dataAdmissao.get(Calendar.DAY_OF_MONTH))  + "/" +
				       nf1.format((dataAdmissao.get(Calendar.MONTH) + 1)) + "/" +
				       dataAdmissao.get(Calendar.YEAR);

		}

		public void setNome(String n)
		{		nome = n;
		}
		
		public void setSalario(double s)
		{		salario = s;
		}
		
		public void setDataAdmissao (String novaDataAdmissao)
		{		int dia = Integer.parseInt(novaDataAdmissao.substring(0,2));
				int mes = Integer.parseInt(novaDataAdmissao.substring(3,5));
				int ano = Integer.parseInt(novaDataAdmissao.substring(6,10));

				dataAdmissao.set(ano, mes - 1, dia);

				// O mtodo parseInt() gera a exceo NumberFormatException
		}

//	public boolean equals (Object num)
//	{		return (new Integer(numero).equals(num));
//	}

		public boolean equals (Object num)
		{		return numero == ((Integer)num).intValue();
		}

		private static NumberFormat nf1, nf2;

		static
		{		nf1 = NumberFormat.getNumberInstance(new Locale("pt","BR"));
				nf2 = NumberFormat.getNumberInstance(new Locale("pt","BR"));
		
				// O primeiro argumento  um ISO Language Code. Os cdigos 
				// possuem duas letras minsculas e encontram-se definidos em ISO-639. 
				// Pode-se encontrar a relao completa em:
				// http://www.ics.uci.edu/pub/ietf/http/related/iso639.txt
						
				// O segundo argumento  um ISO Country Code. Os cdigos 
				// possuem duas letras maisculas e encontram-se definidos em ISO-3166. 
				// Pode-se encontrar a relao completa em:
				// http://www.chemie.fu-berlin.de/diverse/doc/ISO_3166.html 						
						
				// NumberFormat nf = NumberFormat.getNumberInstance();
				// NumberFormat nf = NumberFormat.getCurrencyInstance();

				nf1.setMinimumIntegerDigits (2);     // O default  1.
				nf1.setMaximumIntegerDigits (2);
					
				nf2.setMaximumFractionDigits (2);	   // O default  3.
				nf2.setMinimumFractionDigits (2);
		}
	
		private static int contador = 0;
		private int numero;
		private String nome;
		private double salario;
		private GregorianCalendar dataAdmissao;
}